$(document).ready(function () {
  $('#dmn-file-upload').on('change', loadDmnFromFile);
  $('#dmn-file-empty').on('click', loadEmptyFile);
  $('#dmn-file-download').on('click', download);
  // try to load dmn from session
  loadSessionDmn();
});

function loadDmnFromFile(evt) {
  let files = evt.target.files;
  let dmnFile = files[0];
  let fileReader = new FileReader();
  fileReader.onload = function (fileLoadedEvent) {
    let textFromFileLoaded = fileLoadedEvent.target.result;
    openDiagram(textFromFileLoaded);
  };
  fileReader.readAsText(dmnFile, "UTF-8");
}

function loadEmptyFile() {
  $.ajax({
    url: 'dmn/emptyDMN.dmn',
    type: 'GET',
    cache: false,
    contentType: 'text/xml',
    success: function (data) {
      // TODO, replace definition ID
      data = data.replace("genid1", generateId(8))
      .replace("genid2", generateId(8));
      openDiagram(data);
    }
  });
}

function download() {
  let dmnXml = exportDiagram();
  console.log("xxx:" + dmnXml);
  if (dmnXml !== undefined) {
    let el = document.createElement('a');
    el.setAttribute('href',
        'data:text/xml;charset=utf-8,' + dmnXml);
    el.setAttribute('download', "dmnTable.dmn");
    el.style.display = 'none';
    document.body.appendChild(el);
    el.click();
    document.body.removeChild(el);
  }
}

let oSerializer = new XMLSerializer();

function loadSessionDmn() {
  $.ajax({
    timeout: 1000,
    url: "/dmn",
    type: 'GET',
    contentType: 'application/json',
    error: function (err) {
      // nothing
      console.log(">-->--> loading session dmn failed. <--<--<");
      // loading empty dmn
      loadEmptyFile();
    },
    success: function (data) {
      if (data !== undefined && data.dmnXml !== undefined) {
        // let sXML = oSerializer.serializeToString(data.dmnXml);
        let sXML = data.dmnXml;
        openDiagram(sXML);
      } else {
        loadEmptyFile();
      }
    }
  });
}

function saveSessionDmn() {
  let dmnXml = exportDiagram();
  $.ajax({
    timeout: 1000,
    url: "/dmn/setDmn",
    type: 'POST',
    contentType: 'text/xml',
    data: dmnXml,
    error: function (err) {
      // nothing
      console.log(">-->--> saving session dmn failed. <--<--<");
    }
  });
}

function generateId(length) {
  var result = '';
  var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
  var charactersLength = characters.length;
  for (var i = 0; i < length; i++) {
    result += characters.charAt(Math.floor(Math.random() * charactersLength));
  }
  return result;
}
