/**
 *
 * @param {VerificationEntry}  verificationEntry
 * @param {VerificationFix} fix
 */
function performVerificationFix(verificationEntry, fix, id) {
  console.log("FIX", fix);
  // highlight row
  $('.verification-container').removeClass('highlightsoft');
  $('#ver-entry-' + id).addClass('highlightsoft');
  cleanHighlightFunction();
  for (let i = 0; i < fix.actions.length; i++) {
    switch (fix.actions[i].actionType) {
      case 'SHOW':
        performVerificationFixSHOW(verificationEntry, fix.actions[i]);
        break;
      case 'UPDATE':
        // break;
      case 'INSERT':
        // break;
      case 'DELETE':
        // break;
      default:
        alert("Action not defined!");
    }
    performHighlightFunction();
  }
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function performVerificationFixSHOW(verificationEntry, fixAction) {
  switch (fixAction.actionScope) {
    case 'RULE':
      fixSHOW_RULE(verificationEntry, fixAction);
      break;
    case 'INPUT_ENTRY':
      fixSHOW_INPUT_ENTRY(verificationEntry, fixAction);
      break;
    case 'OUTPUT_ENTRY':
      fixSHOW_OUTPUT_ENTRY(verificationEntry, fixAction);
      break;
    case 'INPUT_DATA':
      fixSHOW_INPUT_DATA(verificationEntry, fixAction);
      break;
    case 'INPUT_COLUMN':
      fixSHOW_INPUT_COLUMN(verificationEntry, fixAction);
      break;
    case 'OUTPUT_COLUMN':
      fixSHOW_OUTPUT_COLUMN(verificationEntry, fixAction);
      break;
    case 'DECISION_TABLE':
      fixSHOW_DECISION_TABLE(verificationEntry, fixAction);
      break;
    case 'DECISION':
      fixSHOW_DECISION(verificationEntry, fixAction);
      break;
    default:
      alert("ACTION: " + fix.actions[i].actionType + ' -> '
          + fix.actions[i].actionScope); // TODO
  }
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_RULE(verificationEntry, fixAction) {
  highlightRules(verificationEntry.elements);
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_INPUT_ENTRY(verificationEntry, fixAction) {
  highlightDataEntries(verificationEntry.elements, 'inputEntryId');
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_INPUT_DATA(verificationEntry, fixAction) {
  highlightInputData(verificationEntry.elements);
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_OUTPUT_ENTRY(verificationEntry, fixAction) {
  highlightDataEntries(verificationEntry.elements, 'outputEntryId');
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_INPUT_COLUMN(verificationEntry, fixAction) {
  highlightColumns(verificationEntry.elements, 'inputId');
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_OUTPUT_COLUMN(verificationEntry, fixAction) {
  highlightColumns(verificationEntry.elements, 'outputId');
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_DECISION_TABLE(verificationEntry, fixAction) {
  highlightDecision(verificationEntry.elements);
}

/**
 *
 * @param {VerificationEntry} verificationEntry
 * @param {Action} fixAction
 */
function fixSHOW_DECISION(verificationEntry, fixAction) {
  highlightDecision(verificationEntry.elements);
}
